
Imports System
Imports System.Xml.Serialization
Imports System.IO

Public Class ApplicationSettings
    Private appSettingsChanged As Boolean
    Private m_defaultDirectory As String
    Private m_Proxy As String
    Private m_user As String
    Private m_passwort As String
    Private m_useProxy As Boolean


    ' Zum Zugreifen auf die Anwendungseinstellungsvariablen verwendete Eigenschaften.      
    Public Property DefaultDirectory() As String
        Get
            Return m_defaultDirectory
        End Get
        Set(ByVal Value As String)
            If Value <> m_defaultDirectory Then
                m_defaultDirectory = Value
                appSettingsChanged = True
            End If
        End Set
    End Property

    Public Property Proxy() As String
        Get
            Return m_Proxy
        End Get
        Set(ByVal Value As String)
            If Value <> m_Proxy Then
                m_Proxy = Value
                appSettingsChanged = True
            End If
        End Set
    End Property

    Public Property User() As String

        Get
            Return m_user
        End Get

        Set(ByVal Value As String)
            If Value <> m_user Then
                m_user = Value
                appSettingsChanged = True
            End If
        End Set

    End Property

    Public Property Passwort() As String

        Get
            Return m_passwort
        End Get

        Set(ByVal Value As String)
            If Value <> m_passwort Then
                m_passwort = Value
                appSettingsChanged = True
            End If
        End Set

    End Property

    Public Property UseProxy() As Boolean

        Get
            Return m_useProxy
        End Get

        Set(ByVal Value As Boolean)
            If Value <> m_useProxy Then
                m_useProxy = Value
                appSettingsChanged = True
            End If
        End Set

    End Property


    ' Serialisiert die Klasse in die Konfigurationsdatei,       
    ' wenn sich Einstellungen gendert haben.       
    Public Function SaveAppSettings() As Boolean

        If Me.appSettingsChanged Then

            Dim myWriter As StreamWriter = Nothing

            Dim mySerializer As XmlSerializer = Nothing

            Try
                ' XmlSerializer fr den               
                ' ApplicationSettings-Typ erstellen.              
                mySerializer = New XmlSerializer( _
                GetType(ApplicationSettings))
                myWriter = New StreamWriter( _
                Application.LocalUserAppDataPath + _
                "\myApplication.config", False)

                ' Diese Instanz der ApplicationSettings-                
                ' Klasse in die Konfigurationsdatei serialisieren.

                mySerializer.Serialize(myWriter, Me)

            Catch ex As Exception
                MessageBox.Show(ex.Message)
            Finally
                ' Wenn FileStream geffnet ist, schlieen.               
                If Not (myWriter Is Nothing) Then
                    myWriter.Close()
                End If

            End Try

        End If

        Return appSettingsChanged

    End Function

    ' Deserialisiert die Klasse aus der Konfigurationsdatei.      
    Public Function LoadAppSettings() As Boolean

        Dim mySerializer As XmlSerializer = Nothing
        Dim myFileStream As FileStream = Nothing
        Dim fileExists As Boolean = False

        Try

            ' XmlSerializer fr den ApplicationSettings-Typ erstellen.            
            mySerializer = New XmlSerializer(GetType(ApplicationSettings))

            Dim fi As New FileInfo(Application.LocalUserAppDataPath + _
            "\myApplication.config")

            ' Falls die Konfigurationsdatei vorhanden ist, diese ffnen.            


            If fi.Exists Then
                myFileStream = fi.OpenRead()

                ' Neue Instanz von ApplicationSettings durch               
                ' Deserialisieren der Konfigurationsdatei erstellen. 

                Dim myAppSettings As ApplicationSettings = CType( _
                mySerializer.Deserialize(myFileStream), _
                ApplicationSettings)

                ' Eigenschaftswerte dieser Instanz                
                ' der ApplicationSettings-Klasse zuweisen. 

                Me.m_Proxy = myAppSettings.m_Proxy

                Me.m_user = myAppSettings.m_user

                Me.m_passwort = myAppSettings.m_passwort

                Me.m_defaultDirectory = myAppSettings.DefaultDirectory

                Me.m_useProxy = myAppSettings.m_useProxy

                fileExists = True

            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        Finally
            ' Wenn FileStream geffnet ist, schlieen.         
            If Not (myFileStream Is Nothing) Then
                myFileStream.Close()
            End If
        End Try

        ' Falls myDirectory nicht festgelegt ist, standardmig   
        ' das Verzeichnis "Eigene Dateien" des Benutzers verwenden.

        If m_defaultDirectory Is Nothing Then
            m_defaultDirectory = Environment.GetFolderPath( _
            System.Environment.SpecialFolder.Personal)
            Me.appSettingsChanged = True
        End If

        Return fileExists

    End Function
End Class

